import React from 'react';
import Box from './Box';
import Placeholder from './Placeholder';
var Container = function (_a) {
    var children = _a.children;
    return (React.createElement(Box, { bgcolor: '#ddd', width: 300 }, children));
};
var docs = {
    name: 'Box',
    examples: [
        {
            description: 'No padding',
            Container: Container,
            Example: function () { return (React.createElement(Box, null,
                React.createElement(Placeholder, { height: 40 }))); },
        },
        {
            description: 'With padding',
            Container: Container,
            Example: function () { return (React.createElement(Box, { padding: 2 },
                React.createElement(Placeholder, { height: 40 }))); },
        },
        {
            description: 'Responsive padding',
            Container: Container,
            Example: function () { return (React.createElement(Box, { padding: [2, 3, 4] },
                React.createElement(Placeholder, { height: 40 }))); },
        },
    ],
};
export default docs;
