import React from 'react';
import Placeholder from './Placeholder';
import Box from './Box';
import Column from './Column';
import Columns from './Columns';
var Container = function (_a) {
    var children = _a.children;
    return (React.createElement(Box, { bgcolor: '#ddd' }, children));
};
var docs = {
    name: 'Columns',
    examples: [
        {
            description: 'No space',
            Container: Container,
            Example: function () { return (React.createElement(Columns, null,
                React.createElement(Column, null,
                    React.createElement(Placeholder, { height: 60 })),
                React.createElement(Column, null,
                    React.createElement(Placeholder, { height: 60 })))); },
        },
        {
            description: 'Custom space',
            Container: Container,
            Example: function () { return (React.createElement(Columns, { space: 2 },
                React.createElement(Column, null,
                    React.createElement(Placeholder, { height: 60 })),
                React.createElement(Column, null,
                    React.createElement(Placeholder, { height: 60 })))); },
        },
        {
            description: 'Responsive space',
            Container: Container,
            Example: function () { return (React.createElement(Columns, { space: [2, 3, 4] },
                React.createElement(Column, null,
                    React.createElement(Placeholder, { height: 60 })),
                React.createElement(Column, null,
                    React.createElement(Placeholder, { height: 60 })))); },
        },
        {
            description: 'Vertically align to center',
            Container: Container,
            Example: function () { return (React.createElement(Columns, { alignY: 'center', space: 2 },
                React.createElement(Column, null,
                    React.createElement(Placeholder, { height: 60 })),
                React.createElement(Column, null,
                    React.createElement(Placeholder, { height: 100 })))); },
        },
        {
            description: 'Vertically align to top',
            Container: Container,
            Example: function () { return (React.createElement(Columns, { alignY: 'top', space: 2 },
                React.createElement(Column, null,
                    React.createElement(Placeholder, { height: 60 })),
                React.createElement(Column, null,
                    React.createElement(Placeholder, { height: 100 })))); },
        },
        {
            description: 'Vertically align to bottom',
            Container: Container,
            Example: function () { return (React.createElement(Columns, { alignY: 'bottom', space: 2 },
                React.createElement(Column, null,
                    React.createElement(Placeholder, { height: 60 })),
                React.createElement(Column, null,
                    React.createElement(Placeholder, { height: 100 })))); },
        },
        {
            description: 'Responsive alignment',
            Container: Container,
            Example: function () { return (React.createElement(Columns, { alignY: ['bottom', 'center', 'top'], space: 2 },
                React.createElement(Column, null,
                    React.createElement(Placeholder, { height: 60 })),
                React.createElement(Column, null,
                    React.createElement(Placeholder, { height: 100 })))); },
        },
        {
            description: 'Collapse below md',
            Container: Container,
            Example: function () { return (React.createElement(Columns, { collapseBelow: 'md', space: 2 },
                React.createElement(Column, null,
                    React.createElement(Placeholder, { height: 60, label: 'First' })),
                React.createElement(Column, null,
                    React.createElement(Placeholder, { height: 60, label: 'Second' })))); },
        },
        {
            description: 'Collapse below lg',
            Container: Container,
            Example: function () { return (React.createElement(Columns, { collapseBelow: 'lg', space: 2 },
                React.createElement(Column, null,
                    React.createElement(Placeholder, { height: 60, label: 'First' })),
                React.createElement(Column, null,
                    React.createElement(Placeholder, { height: 60, label: 'Second' })))); },
        },
        {
            description: 'Collapse below md with responsive space',
            Container: Container,
            Example: function () { return (React.createElement(Columns, { collapseBelow: 'md', space: [2, 3, 4] },
                React.createElement(Column, null,
                    React.createElement(Placeholder, { height: 60, label: 'First' })),
                React.createElement(Column, null,
                    React.createElement(Placeholder, { height: 60, label: 'Second' })))); },
        },
        {
            description: 'Reverse',
            Container: Container,
            Example: function () { return (React.createElement(Columns, { reverse: true, space: 2 },
                React.createElement(Column, null,
                    React.createElement(Placeholder, { height: 60, label: 'First' })),
                React.createElement(Column, null,
                    React.createElement(Placeholder, { height: 60, label: 'Second' })))); },
        },
    ],
};
export default docs;
