var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
import React from 'react';
import Box from './Box';
import { useTheme } from '@material-ui/core/styles';
import toResponsiveProps from '../modules/toResponsiveProps';
import flattenChildren from 'react-keyed-flatten-children';
import getFlexboxAlignForAlignProp from '../modules/getFlexboxAlignForAlignProp';
import getFlexboxAlignForAlignYProp from '../modules/getFlexboxAlignForAlignYProp';
import useNegativeTopMargin from '../modules/useNegativeTopMargin';
var fill = function (defaultFillValue, lengthOfNewArray) {
    return __spread(Array(lengthOfNewArray).keys()).map(function () { return defaultFillValue; });
};
var negative = function (positiveNumber) { return -positiveNumber; };
var useResponsiveDisplay = function (collapseBelow) {
    var theme = useTheme();
    var collapseBelowBreakpointName = collapseBelow || theme.breakpoints.keys[0];
    var indexOfCollapseBreakpoint = collapseBelow
        ? theme.breakpoints.keys.indexOf(collapseBelowBreakpointName)
        : 0;
    return indexOfCollapseBreakpoint > 0
        ? __spread(fill('block', indexOfCollapseBreakpoint), ['flex']) : ['flex'];
};
var Inline = function (_a) {
    var children = _a.children, space = _a.space, align = _a.align, alignY = _a.alignY, collapseBelow = _a.collapseBelow;
    var responsivePadding = toResponsiveProps(space || 0);
    var responsiveAlign = toResponsiveProps(align || 'left');
    var responsiveAlignY = toResponsiveProps(alignY || 'top');
    var display = useResponsiveDisplay(collapseBelow);
    var justifyContent = responsiveAlign.map(getFlexboxAlignForAlignProp);
    var alignItems = responsiveAlignY.map(getFlexboxAlignForAlignYProp);
    var marginLeft = responsivePadding.map(negative);
    var classes = useNegativeTopMargin(responsivePadding);
    return (React.createElement(Box, { className: classes.root },
        React.createElement(Box, { flexWrap: 'wrap', display: display, flexDirection: 'row', marginLeft: marginLeft, alignItems: alignItems, justifyContent: justifyContent }, flattenChildren(children).map(function (child, index) { return (React.createElement(Box, { key: index, minWidth: '0%', display: 'flex', justifyContent: justifyContent, paddingLeft: responsivePadding, paddingTop: responsivePadding }, child)); }))));
};
export default Inline;
