import React from 'react';
import Box from './Box';
import Stack from './Stack';
import Hidden from './Hidden';
import Placeholder from './Placeholder';
var Container = function (_a) {
    var children = _a.children;
    return (React.createElement(Box, { bgcolor: '#ddd' }, children));
};
var docs = {
    name: 'Stack',
    examples: [
        {
            description: 'Space',
            Container: Container,
            Example: function () { return (React.createElement(Stack, { space: 1 },
                React.createElement(Placeholder, { height: 40 }),
                React.createElement(Placeholder, { height: 40 }),
                React.createElement(Placeholder, { height: 40 }))); },
        },
        {
            description: 'Responsive space',
            Container: Container,
            Example: function () { return (React.createElement(Stack, { space: [1, 2, 3] },
                React.createElement(Placeholder, { height: 40 }),
                React.createElement(Placeholder, { height: 40 }),
                React.createElement(Placeholder, { height: 40 }))); },
        },
        {
            description: 'Align to center',
            Container: Container,
            Example: function () { return (React.createElement(Stack, { space: 1, align: 'center' },
                React.createElement(Placeholder, { height: 40, width: 40 }),
                React.createElement(Placeholder, { height: 40, width: 60 }),
                React.createElement(Placeholder, { height: 40, width: 80 }))); },
        },
        {
            description: 'Align to right',
            Container: Container,
            Example: function () { return (React.createElement(Stack, { space: 1, align: 'right' },
                React.createElement(Placeholder, { height: 40, width: 40 }),
                React.createElement(Placeholder, { height: 40, width: 60 }),
                React.createElement(Placeholder, { height: 40, width: 80 }))); },
        },
        {
            description: 'Responsive alignment',
            Container: Container,
            Example: function () { return (React.createElement(Stack, { space: 1, align: ['left', 'right', 'center'] },
                React.createElement(Placeholder, { height: 40, width: 40 }),
                React.createElement(Placeholder, { height: 40, width: 60 }),
                React.createElement(Placeholder, { height: 40, width: 80 }))); },
        },
        {
            description: 'Responsively hiding stack items',
            Container: Container,
            Example: function () { return (React.createElement(Stack, { space: 1 },
                React.createElement(Placeholder, { height: 40, label: '1' }),
                React.createElement(Hidden, { below: 'md' },
                    React.createElement(Placeholder, { height: 40, label: '2' })),
                React.createElement(Hidden, { above: 'sm' },
                    React.createElement(Placeholder, { height: 40, label: '3' })),
                React.createElement(Placeholder, { height: 40, label: '4' }))); },
        },
    ],
};
export default docs;
