var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import React, { Fragment } from 'react';
import Typography from '@material-ui/core/Typography';
import Link from '@material-ui/core/Link';
import PlayIcon from '@material-ui/icons/PlayCircleOutline';
import Button from '@material-ui/core/Button';
import Stack from '../Stack';
import Box from '../Box';
import reactElementToJsxString from 'react-element-to-jsx-string';
import prettier from 'prettier/standalone';
import typescriptParser from 'prettier/parser-typescript';
import { Prism as SyntaxHighlighter } from 'react-syntax-highlighter';
import { ghcolors } from 'react-syntax-highlighter/dist/cjs/styles/prism';
import { createUrl } from 'playroom';
var baseUrl = process.env.NODE_ENV === 'development'
    ? "http://localhost:2223/"
    : "https://mui-primitives.hackart.live/playroom";
var usePrettierToFormatSnippet = function (snippet) {
    return prettier
        .format(snippet, {
        parser: 'typescript',
        plugins: [typescriptParser],
        semi: false,
    })
        .replace(/^;/, '');
};
export var preRenderCodeExample = function (example) {
    var code = usePrettierToFormatSnippet(reactElementToJsxString(example.Example(), {
        useBooleanShorthandSyntax: true,
    }));
    return {
        code: code,
        playroomUrl: createUrl({ code: code, baseUrl: baseUrl }).replace('/#', '#'),
    };
};
export var preRenderCodeExamplesToAvoidMinifiedExamplesInProduction = function (doc) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        return [2 /*return*/, ({
                props: {
                    codeExamples: doc.examples.map(preRenderCodeExample),
                },
            })];
    });
}); };
var Doc = function (_a) {
    var doc = _a.doc, codeExamples = _a.codeExamples;
    return (React.createElement(Stack, { space: 2 },
        React.createElement(Typography, { variant: 'h2' }, doc.name),
        doc.examples.map(function (_a, index) {
            var Example = _a.Example, Container = _a.Container, description = _a.description;
            return (React.createElement(Fragment, { key: index },
                React.createElement(Typography, { variant: 'body1' }, description),
                React.createElement(Container, null,
                    React.createElement(Example, null)),
                React.createElement(Stack, { space: 1 },
                    React.createElement(SyntaxHighlighter, { language: 'javascript', style: ghcolors, customStyle: { margin: 0, border: '1px solid #ddd' } }, codeExamples[index].code),
                    React.createElement(Box, { display: 'flex', justifyContent: 'flex-end' },
                        React.createElement(Button, { size: 'small', component: Link, target: '_blank', startIcon: React.createElement(PlayIcon, null), href: codeExamples[index].playroomUrl }, "Run")))));
        })));
};
export default Doc;
